void Racing::play()
{
	trackDelay = 100;

	distanceCovered = 0;

	trackLength = sizeof(track) / sizeof(byte);

	position = 4;

	laps = 0;

	isCarOn = true;
}

void Racing::update()
{
	if (millis() - flashTimeElapsed > 100)
	{
		flashTimeElapsed = millis();

		isCarOn  = !isCarOn;
	}

	position = map(analogRead(ControllerPotPin) / 10, 0, 102, 2, 7);

	trackDelayElapsed += gameDelay;;

	if(trackDelayElapsed > trackDelay)
	{
		distanceCovered--;

		if (distanceCovered < 0)
		{
			distanceCovered = trackLength;

			laps++;

			if (laps > 1)
			{
				display.flashSprite(up, 2, 250);
			}

			trackDelay -= 10;
		}

		trackDelayElapsed = 0;
	}

	for (int i = 0; i < 8; i++)
	{
		int lOffset = (i + distanceCovered) % trackLength;

		byte lValue = track[lOffset];

		if (i > 5 && isCarOn)
		{
			if ((lValue & (1 << 8-position)) > 0)
			{
				delay(2000);

				gameOver();
			}

			lValue = lValue + (1 << 8 - position);
		}                

		display.drawRow(i, lValue);
	}

}

void Racing::gameOver()
{
	display.flashSprite(lost, 4, 500);

	menu.initialize();
}